"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReferenceSet(ProtocolElement):
    """
    A `ReferenceSet` is a set of `Reference`s which typically comprise a
    reference assembly, such as `GRCh38`. A `ReferenceSet` defines a
    common coordinate space for comparing reference-aligned
    experimental data.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "md5checksum",
        "sourceAccessions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.ReferenceSet": ga4gh_3_0_0.ReferenceSet,
        }

    __slots__ = [
        "id",
        "md5checksum",
        "sourceAccessions",
        "assemblyId",
        "description",
        "isDerived",
        "ncbiTaxonId",
        "sourceURI",
    ]

    def __init__(
        self,
        id,
        md5checksum,
        sourceAccessions,
        assemblyId=None,
        description=None,
        isDerived=False,
        ncbiTaxonId=None,
        sourceURI=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.ReferenceSet model.

        :param id:
            The reference set ID. Unique in the repository.
        :type id: str
        :param md5checksum:
            Order-independent MD5 checksum which identifies this `ReferenceSet`.
            To compute this checksum, make a list of
            `Reference.md5checksum` for all   `Reference`s in this
            set. Then sort that list, and take the MD5 hash of   all
            the strings concatenated together. Express the hash as a
            lower-case   hexadecimal string.
        :type md5checksum: str
        :param sourceAccessions:
            All known corresponding accession IDs in INSDC (GenBank/ENA/DDBJ)
            ideally   with a version number, e.g. `NC_000001.11`.
        :type sourceAccessions: list[str]
        :param assemblyId:
            Public id of this reference set, such as `GRCh37`.
        :type assemblyId: None | str
        :param description:
            Optional free text description of this reference set.
        :type description: None | str
        :param isDerived:
            A reference set may be derived from a source if it contains
            additional sequences, or some of the sequences within it
            are derived   (see the definition of `isDerived` in
            `Reference`).
        :type isDerived: boolean
        :param ncbiTaxonId:
            ID from http://www.ncbi.nlm.nih.gov/taxonomy (e.g. 9606->human)
            indicating   the species which this assembly is intended
            to model. Note that contained   `Reference`s may specify a
            different `ncbiTaxonId`, as assemblies may   contain
            reference sequences which do not belong to the modeled
            species, e.g.   EBV in a human reference genome.
        :type ncbiTaxonId: None | int
        :param sourceURI:
            Specifies a FASTA format file/string.
        :type sourceURI: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
